﻿Imports System.Web.UI.WebControls

Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not Me.IsPostBack Then
            Me.BindGrid()
        End If
    End Sub

    Private Sub BindGrid()
        Using ctx As New CustomersDataContext()
            GridView1.DataSource = From customer In ctx.Customers
                                   Select customer
            GridView1.DataBind()
        End Using
    End Sub

    Protected Sub Insert(sender As Object, e As EventArgs)
        Using ctx As New CustomersDataContext()
            Dim customer As New Customer() With {
              .Name = txtName.Text,
              .Country = txtCountry.Text
            }
            ctx.Customers.InsertOnSubmit(customer)
            ctx.SubmitChanges()
        End Using
        txtName.Text = ""
        txtCountry.Text = ""
        Me.BindGrid()
    End Sub

    Protected Sub OnRowEditing(sender As Object, e As GridViewEditEventArgs)
        GridView1.EditIndex = e.NewEditIndex
        Me.BindGrid()
    End Sub

    Protected Sub OnRowCancelingEdit(sender As Object, e As EventArgs)
        GridView1.EditIndex = -1
        Me.BindGrid()
    End Sub

    Protected Sub OnRowUpdating(sender As Object, e As GridViewUpdateEventArgs)
        Dim row As GridViewRow = GridView1.Rows(e.RowIndex)
        Dim customerId As Integer = Convert.ToInt32(GridView1.DataKeys(e.RowIndex).Values(0))
        Dim name As String = TryCast(row.FindControl("txtName"), TextBox).Text
        Dim country As String = TryCast(row.FindControl("txtCountry"), TextBox).Text
        Using ctx As New CustomersDataContext()
            Dim customer As Customer = (From c In ctx.Customers Where c.CustomerId = customerId
                                        Select c).FirstOrDefault()
            customer.Name = name
            customer.Country = country
            ctx.SubmitChanges()
        End Using
        GridView1.EditIndex = -1
        Me.BindGrid()
    End Sub

    Protected Sub OnRowDataBound(sender As Object, e As GridViewRowEventArgs)
        If e.Row.RowType = DataControlRowType.DataRow AndAlso e.Row.RowIndex <> GridView1.EditIndex Then
            TryCast(e.Row.Cells(2).Controls(2), LinkButton).Attributes("onclick") = "return confirm('Do you want to delete this row?');"
        End If
    End Sub

    Protected Sub OnRowDeleting(sender As Object, e As GridViewDeleteEventArgs)
        Dim customerId As Integer = Convert.ToInt32(GridView1.DataKeys(e.RowIndex).Values(0))
        Using ctx As New CustomersDataContext()
            Dim customer As Customer = (From c In ctx.Customers Where c.CustomerId = customerId
                                        Select c).FirstOrDefault()
            ctx.Customers.DeleteOnSubmit(customer)
            ctx.SubmitChanges()
        End Using
        Me.BindGrid()
    End Sub
End Class
